#include "swordlib.h"
#include <cstdlib>
#include <cstdio>

#define MAX_N 300

static int sl[MAX_N];
static int dl[MAX_N];
static int slcount;
static int dlcount;

static void finish(const char* msg)
{
  printf("%s",msg);
  exit(0);
}

void sword_init(int* scount, int* slen, int* dcount, int* dlen)
{
  scanf("%d",scount);
  for(int i=0; i<(*scount); i++) {
    scanf("%d",&slen[i]);
    sl[i] = slen[i];
  }
  scanf("%d",dcount);
  for(int i=0; i<(*dcount); i++) {
    scanf("%d",&dlen[i]);
    dl[i] = dlen[i];
  }

  slcount = *scount;
  dlcount = *dcount;
}

static bool check_done()
{
  for(int i=0; i<slcount; i++)
    if(sl[i]!=0)
      return false;
  for(int i=0; i<dlcount; i++)
    if(dl[i]!=0)
      return false;
  return true;
}

static void do_cut(int type, int orglen, int newlen)
{
  if(type==1) {
    for(int i=0; i<slcount; i++)
      if(sl[i]==orglen) {
	sl[i] = newlen;
	return;
      }
  } else {
    for(int i=0; i<dlcount; i++)
      if(dl[i]==orglen) {
	dl[i] = 0;
	sl[slcount] = newlen;
	sl[slcount+1] = orglen-newlen;
	slcount += 2;
	return;
      }
  }
  finish("Error: orglen not found\n");    
}

void sword_cut(int type, int orglen, int newlen)
{
  if(newlen>=orglen)
    finish("Error: newlen >= orglen\n");

  do_cut(type, orglen, newlen);
  if(check_done())
    finish("Good, your program wins\n");
}

void sword_watch(int* type, int* orglen, int* newlen)
{
  scanf("%d %d %d", type, orglen, newlen);
  do_cut(*type, *orglen, *newlen);
  if(check_done())
    finish("Sorry, your program fails.\n");
}
